
      Subroutine Incoherent(awz)
c     ==================================================================
c     Compute elnergy lost and spread due to Synchrtron radiation
c     Only Correct for Planar undulators (almost correct for Helical)
c     From  draft by S. Reichle, modified by P. Elleaume  August 1999
c     The effect ofenergy loss and spread  has been tested successfully
c     with respect to E. Saldin NIMA381 (1996) p 545-547
c     ------------------------------------------------------------------
c
c
      INCLUDE  'genesis.def'
      INCLUDE  'input.cmn'
      INCLUDE  'particle.cmn'
c
      INTEGER IP,MPART,k
      real*8 tmp2,gam0,dgamavg,dgamsig,xkw0,awz
c
      IF (awz.lt.TINY) RETURN  !drift section!
      IF ((ISRAVG.EQ.0).AND.(ISRSIG.EQ.0)) RETURN 
c
      xkw0=twopi/xlamd
      gam0=0.
      do ip=1,npart
         gam0=gam0+gamma(IP)
      enddo
      gam0=gam0/dble(NPART)
c
c     Increase of energy spread
c
      dgamsig=1.015d-27*(xkw0*awz)**2*(1.697*awz+
     +     1./(1.+1.88*awz+0.8*awz**2)) 
      IF (IWITYP.NE.0) THEN                              !helical undulator
         dgamsig=1.015d-27*(xkw0*awz)**2*(1.42*awz+
     +           1./(1.+1.5*awz+0.95*awz**2))
      ENDIF
c
      dgamsig=DSQRT(dgamsig*gam0**4*xkw0*XLAMD*DELZ)*SQRT(3.)
     c        *DBLE(ISRSIG) !sqrt(3) uniform distribution
c
c     average energy loss
c
      dgamavg=1.88d-15*(xkw0*gam0*awz)**2
     c        *DELZ*XLAMD*DBLE(ISRAVG)
c
      MPART=NPART/DBLE(NBINS)
      GAM0=0.
      IF  (ISRSIG.NE. 0) THEN
          DO ip=1,MPART
             tmp2=(2.*Ran1(ISEED)-1.)*dgamsig
             GAM0=GAM0+tmp2
             DO k=0,NBINS-1
               GAMMA(IP+k*MPART)=GAMMA(IP+k*MPART)+tmp2
             ENDDO  
          ENDDO
      ENDIF
      gam0=gam0/DBLE(MPART)
      IF (GAM0+dgamavg .NE. 0.) THEN
         DO IP=1,NPART
            GAMMA(IP)=GAMMA(IP)-GAM0-dgamavg
         ENDDO
      ENDIF
c
      Return
      End     !SR
c


