      Subroutine initrun
c     ==================================================================
c     initialize the run by setting up
c     the precalculated matrices for the field solver and
c     claculating/normalizing some auxiliary variables
c
c     ------------------------------------------------------------------
c
      include 'genesis.def'
      include 'input.cmn'
      include 'particle.cmn'
      include 'sim.cmn'
      include 'field.cmn'
      include 'time.cmn'
      include 'magnet.cmn'
c
      REAL*8 XI
      INTEGER IP

c
c     Seeding of random number generator
c
      xi=RAN1(ISEED)          !init RAN1
c
c     calculate coupling factor if necessary
c
      IF(FBESS0.EQ.0.) THEN
         IF (IWITYP.EQ.0) THEN
     	    XI = AW0**2/(1.D0+AW0**2)/2
	    FBESS0 = BESSJ0(XI) - BESSJ1(XI)
         ELSE
            FBESS0=1.
         ENDIF
      ENDIF
c
      DEDZ=ELOSS*DELZ*XLAMD/EEV
      xcuren=curpeak
c
c     NORMALIZATIONS
c     ------------------------------------------------------------------
c
      XKW0= TWOPI/XLAMD                       !Wiggler wavenumber
      XKPER0 = XKW0                           !transverse normalisation
c
c     MAGNETIC FIELD
c     ------------------------------------------------------------------   
c
      CALL MAGFIELD(XKPER0)                   !magnetic field description
c
c     Slipping length
c
      NSEP=INT(ZSEP/DELZ)                      !steps between field slippage
      NSLP=NSTEPZ/NSEP                         !Total slippage steps
c
c     contruct grid properties (grid spacing, precalculated matrices)
c
      DXY=xkw0*2.D0*DGRID/float(NCAR-1)    
      xks=TWOPI/XLAMDS
c
c     TIME DEPENDENCIES
c
      CALL LOADSLPFLD(NSLP)        !input field for first slice and seeding of ran-function
c
c     SCANNING
c
      CALL SCANINIT   !initialize scanning
c
c     Matrix initialization
c
      call getdiag(DELZ*XLAMD,DXY/XKPER0,XKS)
c
c     clear space charge field for case that space charge is disabled
c
      Do IP=1,NPART   !clear space charge term
         EZ(IP)=0.d0
      End Do       ! IP

c
c
      RETURN
      END
c
