      SUBROUTINE OUTPUT(ISTEPZ,ISLICE,xkw0)
c     =============================================
c     calls all output function
c     ---------------------------------------------
c
      include 'genesis.def'
      include 'io.cmn'
c
      integer istepz,islice
      REAL*8  xkw0
c
      call diagno(istepz,xkw0)
      if (ISLICE.LE.firstout) RETURN
      IF (ISTEPZ.EQ.0) CALL OUTHISTHEADER(ISLICE)
      CALL OUTHIST(ISTEPZ,ISLICE)
      CALL OUTFIELD(ISTEPZ,ISLICE,xkw0)
      CALL OUTPART(ISTEPZ,ISLICE,xkw0)
      CALL STATUS(ISTEPZ,ISLICE)
      RETURN
      END

      FUNCTION OPENOUTPUTFILE(ierror)
c     ==================================================================
c     Initial output of GENESIS.
c     ------------------------------------------------------------------
c
      INCLUDE 'genesis.def'
      include 'input.cmn'
      include 'io.cmn'
      include 'sdds.cmn'
      INCLUDE "SDDSFortran.h"
c
      INTEGER ierror,i,j,isdefined,istr
c
      CHARACTER*30 sddsformat
      CHARACTER*30 cname
      DIMENSION cNamesD(23)
      CHARACTER*30 cNamesD
c
      isdefined=0
      IF (ierror.EQ.ERROPENIN) THEN 
        outputfile='template.in'   !input file not file -> generate template
      ELSE
        isdefined=1 
         IF (INDEX(OUTPUTFILE,' ').EQ.1) THEN    !no outputfile defined -> ask for it
            isdefined=0
            if (ILOG.NE.0) then
              i=PRINTERR(ERRREQUEST,'OUTPUTFILE')   !interaction required
              call last
            endif
 1          write(6,100) 
            read(5,105) outputfile       !output file name not defined
            IF (INDEX(outputfile,' ').EQ.1) then
               i=PRINTERR(ERRINVALNAME,outputfile)
               goto 1
            ENDIF 
            write(6,120)
            read(5,105) sddsformat
            SDDS = 1
            if ((sddsformat .EQ. "N") .OR. (sddsformat .EQ. "n")) then
               SDDS = 0
            endif
         ENDIF                           !ask for output filename  
      ENDIF
c
      NOUT=9
      OPENOUTPUTFILE=NOERR
      if (SDDS .EQ. 0) then
         Open(nout,file=outputfile,ERR=10,status='unknown') !Open input file.
      else
         i = SDDS_InitializeOutput_F(2,SDDS_BINARY,1,
     +        "GENESIS Simulation Results",
     +        "",outputfile)
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         endif
         SDDSNOUTPAGESTARTED = 0
      endif
c     
      if (ierror.eq.NOERR)  THEN
        write(nout,110) GENVER,PLATF,inputfile
      endif

c
c     dump input parmeters
c
      if (SDDS .EQ. 0) then
         WRITE(NOUT,1000)
     +        AW0,XKX,XKY,(WCOEFZ(i),i=1,3),XLAMD,FBESS0,DELAW,
     +        IERTYP,IWITYP,AWD,ISEED,
     +        NPART,GAMMA0,DELGAM,RXBEAM,RYBEAM,ALPHAX,ALPHAY,
     +        EMITX,EMITY,XBEAM,YBEAM,PXBEAM,PYBEAM,
     +        XLAMDS,PRAD0,ZRAYL,ZWAIST
         WRITE(NOUT,1001)
     +        NCAR,LBC,RMAX0,DGRID,NSCR,NSCZ,NPTR,
     +        NWIG,ZSEP,DELZ,NSEC,IORB,ZSTOP,MAGIN,MAGOUT,
     +        QUADF,QUADD,FL,DL,DRL,F1ST,QFDX,QFDY,SOLEN,SL,
     +        ILDGAM,ILDPSI,ILDX,ILDY,ILDPX,ILDPY,ITGAUS,NBINS,
     +        (LOUT(i),i=1,14+NHMAX)
         WRITE(NOUT,1002)
     +        IPHSTY,ISHSTY,IPPART,ISPART,IPRADI,ISRADI,
     +        IDUMP,IOTAIL,NHARM,   
     +        CURPEAK,CURLEN,NTAIL,NSLICE,SHOTNOISE,IALL,ITDP,IPSEED,
     +        ISCAN,NSCAN,SVAR,ISRAVG,ISRSIG,CUTTAIL,ELOSS,
     +        VERSION,CHARGE,NDCUT  
         WRITE(NOUT,1003)
     +        IDMPFLD,IDMPPAR,ILOG
c
         istr=strlen(BEAMFILE)
         IF (istr.gt.1) 
     c        WRITE(NOUT,1010) 'BEAMFILE =',BEAMFILE(1:istr)
         istr=strlen(FIELDFILE)
         IF (istr.gt.1) 
     c        WRITE(NOUT,1010) 'FIELDSFILE =',FIELDFILE(1:istr)
         istr=strlen(SCAN)
         IF (istr.gt.1) 
     c        WRITE(NOUT,1010) 'SCAN =',SCAN(1:istr)
         istr=strlen(OUTPUTFILE)
         IF ((istr.gt.1).and.(isdefined.ne.0)) 
     c        WRITE(NOUT,1010) 'OUTPUTFILE =',OUTPUTFILE(1:istr)
         istr=strlen(MAGINFILE)
         IF (istr.gt.1) 
     c        WRITE(NOUT,1010) 'MAGINFILE =',MAGINFILE(1:istr)
         istr=strlen(MAGOUTFILE)
         IF (istr.gt.1) 
     c        WRITE(NOUT,1010) 'MAGOUTFILE =',MAGOUTFILE(1:istr)
         istr=strlen(PARTFILE)
         IF (istr.gt.1) 
     c        WRITE(NOUT,1010) 'PARTFILE =',PARTFILE(1:istr)
         istr=strlen(DISTFILE)
         IF (istr.gt.1) 
     c        WRITE(NOUT,1010) 'DISTFILE =',DISTFILE(1:istr)
         istr=strlen(FILETYPE)
         IF (istr.gt.1) 
     c        WRITE(NOUT,1010) 'FILETYPE =',FILETYPE(1:istr)
         WRITE(NOUT,1020) '$end'
      else
         cNamesD(1) = "Energy"
         cNamesD(2) = "Phase"
         cNamesD(3) = "XPosition"
         cNamesD(4) = "YPosition"
         cNamesD(5) = "XMomentum"
         cNamesD(6) = "YMomentum"
         cNamesD(7) = "ZPhase"
         cNamesD(8) = "Theta"
c
         cNamesD(9) = "s"
         cNamesD(10) = "gamma"
         cNamesD(11) = "dgamma"
         cNamesD(12) = "xemit"
         cNamesD(13) = "yemit"
         cNamesD(14) = "xrms"
         cNamesD(15) = "yrms"
         cNamesD(16) = "xavg"
         cNamesD(17) = "yavg"
         cNamesD(18) = "pxavg"
         cNamesD(19) = "pyavg"
         cNamesD(20) = "alphax"
         cNamesD(21) = "alphay"
         cNamesD(22) = "current"
         cNamesD(23) = "wakez"

         call DEFINESDDSPARAMETERS(2)
         i = SDDS_DefineColumn_F(2,"Z","","m","","",
     +        SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"Aw","","","","",
     +        SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"Qfld","","","","",
     +        SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"Power","","W","","",
     +        SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"Increment","","","Growth Rate","",
     +        SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"PowerMid","","W",
     *        "Radiation Power at Center","",SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"RealFieldMid","","W",
     *        "Radiation Field at Center (Real)","",SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"ImagFieldMid","","W",
     *        "Radiation Field at Center (Imag)","",SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"PhaseMid","","rad",
     *        "Radiation Phase at Center","",SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"W",
     *        "Radiation Radius","m",
     *        "","",SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"Wp","Radiation Divergence","rad",
     *        "","",SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"Energy","","",
     *        "Beam Energy","",SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         do j=1,NHMAX
            write(cname,'(I1)') j
            cname = 'Bunching_' // cname
            i = SDDS_DefineColumn_F(2,cname,"","",
     *           "Bunching","",SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            write(cname,'(I1)') j
            cname = 'RealBunching_' // cname
            i = SDDS_DefineColumn_F(2,cname,"","",
     *           "Real Bunching","",SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            write(cname,'(I1)') j
            cname = 'ImagBunching_' // cname
            i = SDDS_DefineColumn_F(2,cname,"","",
     *           "Imag Bunching","",SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         enddo
         i = SDDS_DefineColumn_F(2,"Xrms","","m",
     *        "Average Beam Size-X","",SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"Yrms","","m",
     *        "Average Beam Size-Y","",SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"Xp","X position","m",
     *        "","",SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"Yp","Y position","m",
     *        "","",SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"Error","","",
     *        "Error","",SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"E-Spread","","",
     *        "Energy Spread","",SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineColumn_F(2,"FarField","","",
     *        "Far Field","",SDDS_DOUBLE,0)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if

      endif
c
c
      RETURN 
c
 10   OPENOUTPUTFILE=PRINTERR(ERROPEN,outputfile)
      RETURN
c
c     format statement 
c
 100  Format('PLEASE ENTER OUTPUT FILE NAME ')
 105  Format(a30)
 110  Format(/,'--------------------------------------',/,
     c         'GENESIS 1.3 OUTPUT START',/,
     c         '(Version ',f3.1,' ',a,')',/,/,
     c         'INPUT FILE NAME:  ',a30,/)
c
 120  Format('SDDS output [Y]es/[N]o ')
 1000 FORMAT(1X,'$newrun',/, 
     +       1X,'AW0   =',1PD14.6,/,
     +       1X,'XKX   =',1PD14.6,/,
     +       1X,'XKY   =',1PD14.6,/,
     +       1X,'WCOEFZ=',3(1PD14.6,1X),/,
     +       1X,'XLAMD =',1PD14.6,/,
     +       1X,'FBESS0=',1PD14.6,/,
     +       1X,'DELAW =',1PD14.6,/,
     +       1X,'IERTYP=',I5,/,
     +       1X,'IWITYP=',I5,/,
     +       1X,'AWD   =',1PD14.6,/,
     +       1X,'ISEED =',I5,/,
     +       1X,'NPART =',I5,/,
     +       1X,'GAMMA0=',1PD14.6,/,
     +       1X,'DELGAM=',1PD14.6,/,
     +       1X,'RXBEAM=',1PD14.6,/,
     +       1X,'RYBEAM=',1PD14.6,/,
     +       1X,'ALPHAX=',1PD14.6,/,
     +       1X,'ALPHAY=',1PD14.6,/,
     +       1X,'EMITX =',1PD14.6,/,
     +       1X,'EMITY =',1PD14.6,/,
     +       1X,'XBEAM =',1PD14.6,/,
     +       1X,'YBEAM =',1PD14.6,/,
     +       1X,'PXBEAM=',1PD14.6,/,
     +       1X,'PYBEAM=',1PD14.6,/,
     +       1X,'XLAMDS=',1PD14.6,/,
     +       1X,'PRAD0 =',1PD14.6,/,
     +       1X,'ZRAYL =',1PD14.6,/,
     +       1X,'ZWAIST=',1PD14.6)
 1001 FORMAT(1X,'NCAR  =',I5,/,
     +       1X,'LBC   =',I5,/,
     +       1X,'RMAX0 =',1PD14.6,/,
     +       1X,'DGRID =',1PD14.6,/,
     +       1X,'NSCR  =',I5,/,
     +       1X,'NSCZ  =',I5,/,
     +       1X,'NPTR  =',I5,/,
     +       1X,'NWIG  =',I5,/,
     +       1X,'ZSEP  =',1PD14.6,/,
     +       1X,'DELZ  =',1PD14.6,/,
     +       1X,'NSEC  =',I5,/,
     +       1X,'IORB  =',I5,/,
     +       1X,'ZSTOP =',1PD14.6,/,
     +       1X,'MAGIN =',I5,/,
     +       1X,'MAGOUT=',I5,/,
     +       1X,'QUADF =',1PD14.6,/,
     +       1X,'QUADD =',1PD14.6,/,
     +       1X,'FL    =',1PD14.6,/,
     +       1X,'DL    =',1PD14.6,/,
     +       1X,'DRL   =',1PD14.6,/,
     +       1X,'F1ST  =',1PD14.6,/,
     +       1X,'QFDX  =',1PD14.6,/,
     +       1X,'QFDY  =',1PD14.6,/,
     +       1X,'SOLEN =',1PD14.6,/,
     +       1X,'SL    =',1PD14.6,/,
     +       1X,'ILDGAM=',I5,/,
     +       1X,'ILDPSI=',I5,/,
     +       1X,'ILDX  =',I5,/,
     +       1X,'ILDY  =',I5,/,
     +       1X,'ILDPX =',I5,/,
     +       1X,'ILDPY =',I5,/,
     +       1X,'ITGAUS=',I5,/,
     +       1X,'NBINS =',I5,/,
     +       1X,'LOUT  =',20(1X,I1))
 1002 FORMAT(1X,'IPHSTY=',I5,/,
     +       1X,'ISHSTY=',I5,/,
     +       1X,'IPPART=',I5,/,
     +       1X,'ISPART=',I5,/,
     +       1X,'IPRADI=',I5,/,
     +       1X,'ISRADI=',I5,/,
     +       1X,'IDUMP =',I5,/,
     +       1X,'IOTAIL=',I5,/,
     +       1X,'NHARM =',I5,/,
     +       1X,'CURPEAK=',1PD14.6,/,
     +       1X,'CURLEN=',1PD14.6,/,
     +       1X,'NTAIL =',I5,/,
     +       1X,'NSLICE=',I5,/,
     +       1X,'SHOTNOISE=',1PD14.6,/,
     +       1X,'IALL  =',I5,/,
     +       1X,'ITDP  =',I5,/,
     +       1X,'IPSEED=',I5,/,
     +       1X,'ISCAN =',I5,/,
     +       1X,'NSCAN =',I5,/,
     +       1X,'SVAR  =',1PD14.6,/,
     +       1X,'ISRAVG=',I5,/,
     +       1X,'ISRSIG=',I5,/,
     +       1X,'CUTTAIL=',1PD14.6,/,
     +       1X,'ELOSS =',1PD14.6,/,
     +       1X,'VERSION=',1PD14.6,/,
     +       1X,'CHARGE=',1PD14.6,/,
     +       1X,'NDCUT =',I5)
 1003 FORMAT(1X,'IDMPFLD=',I5,/,
     +       1X,'IDMPPAR=',I5,/,
     +       1X,'ILOG  =',I5)  
 1010 FORMAT(1x,a,1h',A,1h')
 1020 FORMAT(1x,A4)
      END !of OUTHEADER
c
c
      SUBROUTINE OUTGLOB
c     ==================================================================
c     Output of global parameter (t-independend): 
c     z, wiggler field
c     ------------------------------------------------------------------
c
      INCLUDE  'genesis.def'
      INCLUDE  'input.cmn'
      include  'magnet.cmn'
      INCLUDE  'io.cmn'
      include  'field.cmn'
      include  'sim.cmn'
      include  'time.cmn'
      include 'sdds.cmn'
      INCLUDE "SDDSFortran.h"
c
      INTEGER iz,ITMP,i1,i2,i3,i,j
      CHARACTER*14 TITEL
      character*40 cwarn
      DIMENSION TITEL(3)
c
      DIMENSION pNamesS(2)
      CHARACTER*30 pNamesS
      DIMENSION pNamesL(8)
      CHARACTER*30 pNamesL
      DIMENSION pNamesD(3)
      CHARACTER*30 pNamesD
      DIMENSION pValuesS(2)
      CHARACTER*30 pValuesS
      DIMENSION pValuesL(8)
      INTEGER pValuesL
      DIMENSION pValuesD(3)
      REAL*8 pValuesD
c
c     ------------------------------------------------------------------ 
c     output of t independent values 
c
c     Parameter for IDL about file size etc.
c
      if (SDDS .EQ. 0) then
         WRITE(NOUT,10) 'Flags for Output Parameter'
         Write(NOUT,13) (LOUT(iz),IZ=1,14+NHMAX)
c     
         ITMP=0
         IF (IPHSTY.GT.0) ITMP=INT(NSTEPZ/IPHSTY)+1
         WRITE(NOUT,11) ITMP,' Entries per Record'
         i1=ITMP
c     
         ITMP=NSLICE
         FIRSTOUT=NSLP*(1-IOTAIL)*ITDP !=0 for scan, steady state and IOTAIL=1 cases
         IF (ITDP.NE.0) ITMP=NSLICE-NSLP*(1-IOTAIL) 
         ITMP=INT(ITMP/ISHSTY)
         WRITE(NOUT,11) ITMP,' History Records'
c     
         WRITE(NOUT,12) XLAMDS, ' Wavelength'
         WRITE(NOUT,12) DBLE(ISHSTY)*ZSEP*XLAMDS, 
     c        ' Seperation of Output Slices'
c     
         WRITE(NOUT,11) NCAR,' Number of Gridpoints'
         WRITE(NOUT,12) DXY/XKPER0,' Meshsize'
         WRITE(NOUT,11) NPART,' Number of Particles'
c     
         IF (IPPART.GT.0) THEN
            WRITE(NOUT,11) NSTEPZ/IPPART+1,' Particle: Records in z'
            WRITE(NOUT,11) ITMP/ISPART,' Particle: Records in t'
         ELSE
            WRITE(NOUT,11) 0,' Particle: Records in z'
            WRITE(NOUT,11) 0,' Particle: Records in t'
         ENDIF
         IF (IPRADI.GT.0) THEN
            WRITE(NOUT,11) NSTEPZ/IPRADI+1,' Field: Records in z'
            WRITE(NOUT,11) ITMP/ISRADI,' Field: Records in t'
         ELSE
            WRITE(NOUT,11) 0,' Field: Records in z'
            WRITE(NOUT,11) 0,' Field: Records in t'
         ENDIF
      else
c
         pNamesS(1) = "Variable1Name"
         pValuesS(1) = "x"
         pNamesS(2) = "Variable2Name"
         pValuesS(2) = "y"
c
         pNamesD(1) = "Wavelength"
         pNamesD(2) = "SeperationOfSlices"
         pNamesD(3) = "Meshsize"
c
         pNamesL(1) = "EntriesPerRecord"
         pNamesL(2) = "HistoryRecords"
         pNamesL(3) = "NumberOfGridpoints"
         pNamesL(4) = "NumberOfParticles"
         pNamesL(5) = "ParticleRecordsInZ"
         pNamesL(6) = "ParticleRecordsInT"
         pNamesL(7) = "FieldRecordsInZ"
         pNamesL(8) = "FieldRecordsInT"
c
         ITMP=0
         IF (IPHSTY.GT.0) ITMP=INT(NSTEPZ/IPHSTY)+1
         i1=ITMP
         pValuesL(1) = ITMP
c     
         ITMP=NSLICE
         FIRSTOUT=NSLP*(1-IOTAIL)*ITDP !=0 for scan, steady state and IOTAIL=1 cases
         IF (ITDP.NE.0) ITMP=NSLICE-NSLP*(1-IOTAIL) 
         ITMP=INT(ITMP/ISHSTY)
         pValuesL(2) = ITMP
c     
         pValuesD(1) = XLAMDS
         pValuesD(2) = DBLE(ISHSTY)*ZSEP*XLAMDS
c     
         pValuesL(3) = NCAR
         pValuesD(3) = DXY/XKPER0
         pValuesL(4) = NPART
c     
         IF (IPPART.GT.0) THEN
            pValuesL(5) = NSTEPZ/IPPART+1
            pValuesL(6) = ITMP/ISPART
         ELSE
            pValuesL(5) = 0
            pValuesL(6) = 0
         ENDIF
         IF (IPRADI.GT.0) THEN
            pValuesL(7) = NSTEPZ/IPRADI+1
            pValuesL(8) = ITMP/ISRADI
         ELSE
            pValuesL(7) = 0
            pValuesL(8) = 0
         ENDIF
         do j = 1,3
            i = SDDS_DefineParameter1_F(2,pNamesD(j),"","","","",
     +           SDDS_DOUBLE,pValuesD(j))
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         end do
         do j = 1,8
            i = SDDS_DefineParameter1_F(2,pNamesL(j),"","","","",
     +           SDDS_LONG,pValuesL(j))
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         end do
         i = SDDS_DefineParameter_F(2,"Slice","","","Slice Number",
     +        "",SDDS_LONG,"")
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_DefineParameter_F(2,"SliceString","","","","",
     +        SDDS_STRING,"")
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         if (iscan.le.0) then 
            i = SDDS_DefineParameter_F(2,"Current","","A","",
     +           "",SDDS_DOUBLE,"")
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter_F(2,"CurrentString","","Amp","","",
     +           SDDS_STRING,"")
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         else
            i = SDDS_DefineParameter_F(2,"ScanValue","","A","",
     +           "",SDDS_DOUBLE,"")
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter_F(2,"ScanValueString","","","","",
     +           SDDS_STRING,"")
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if               
         endif
c
         i = SDDS_WriteLayout_F(2)
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
c
         if (NPAR .NE. -1) then
            do j = 1,3
               i = SDDS_DefineParameter1_F(3,pNamesD(j),"","","","",
     +              SDDS_DOUBLE,pValuesD(j))
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
            end do
            do j = 1,8
               i = SDDS_DefineParameter1_F(3,pNamesL(j),"","","","",
     +              SDDS_LONG,pValuesL(j))
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
            end do
            i = SDDS_DefineParameter_F(3,"Slice","","","Slice Number",
     +           "",SDDS_LONG,"")
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter_F(3,"Z","","m","","",
     +           SDDS_DOUBLE,"")
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter_F(3,"Zstring","","m","","",
     +           SDDS_STRING,"")
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter_F(3,"Current","","A","",
     +           "",SDDS_DOUBLE,"")
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
c     
            i = SDDS_WriteLayout_F(3)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         end if
c
         if (NDMP2 .NE. -1) then
            do j = 1,3
               i = SDDS_DefineParameter1_F(9,pNamesD(j),"","","","",
     +              SDDS_DOUBLE,pValuesD(j))
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
            end do
            do j = 1,8
               i = SDDS_DefineParameter1_F(9,pNamesL(j),"","","","",
     +              SDDS_LONG,pValuesL(j))
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
            end do
            i = SDDS_DefineParameter_F(9,"Slice","","","Slice Number",
     +           "",SDDS_LONG,"")
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter_F(9,"Z","","m","","",
     +           SDDS_DOUBLE,"")
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter_F(9,"Zstring","","m","","",
     +           SDDS_STRING,"")
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter_F(9,"Current","","A","",
     +           "",SDDS_DOUBLE,"")
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
c     
            i = SDDS_WriteLayout_F(9)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         end if
c
         SDDSNFLDSTARTED = 0
         if (NFLD .NE. -1) then
            do j = 1,3
               i = SDDS_DefineParameter1_F(4,pNamesD(j),"","","","",
     +              SDDS_DOUBLE,pValuesD(j))
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
            end do
            do j = 1,8
               i = SDDS_DefineParameter1_F(4,pNamesL(j),"","","","",
     +              SDDS_LONG,pValuesL(j))
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
            end do
            do j = 1,2
               i = SDDS_DefineParameter_F(4,pNamesS(j),"","","","",
     +              SDDS_STRING,pValuesS(j))
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
            end do
            if (LOUT(6).NE.0) then
               do j = 1,3
                  i = SDDS_DefineParameter1_F(8,pNamesD(j),"","","","",
     +                 SDDS_DOUBLE,pValuesD(j))
                  if (i .LT. 0) then
                     call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                     stop 1
                  end if
               end do
               do j = 1,8
                  i = SDDS_DefineParameter1_F(8,pNamesL(j),"","","","",
     +                 SDDS_LONG,pValuesL(j))
                  if (i .LT. 0) then
                     call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                     stop 1
                  end if
               end do
               do j = 1,2
                  i = SDDS_DefineParameter_F(8,pNamesS(j),"","","","",
     +                 SDDS_STRING,pValuesS(j))
                  if (i .LT. 0) then
                     call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                     stop 1
                  end if
               end do
            end if
         endif
      endif
c
c     Calculation of output filesizes.
c     
      IF ((ITDP.NE.0).OR.(ISCAN.GT.0)) THEN
         i2=0
         DO i3=1,14+NHMAX
             i2=i2+LOUT(i3)       !count number of output parameters
         ENDDO
         IF (ISCAN.GT.0) ITMP=NSCAN
         i2=i2*14                 !each entry has 14 character
         i2=i2*i1*ITMP/1024/1024  !mutiply by #records and lines per record
         IF (i2.GT.1) THEN
            write(cwarn,50) 'history',i2
            i2=PRINTERR(ERRLARGEOUT,cwarn)
         ENDIF
      ENDIF
      IF (IPPART.GT.0) THEN
         i2=(NSTEPZ/IPPART+1)*ITMP/ISPART !number of records and entries
         i2=i2*6*8*NPART/1024/1024        !6 variables (real*8) per particle
         IF (i2.GT.1) THEN
            write(cwarn,50) 'particle',i2
            i2=PRINTERR(ERRLARGEOUT,cwarn)
         ENDIF
      ENDIF
      IF (IPRADI.GT.0) THEN
         i2=(NSTEPZ/IPRADI+1)*ITMP/ISRADI !number of records and entries
         i2=i2*16*NCAR*NCAR/1024/1024     !NCAR**2 grid points (complex*16) 
         IF (i2.GT.1) THEN
            write(cwarn,50) 'radiation',i2
            i2=PRINTERR(ERRLARGEOUT,cwarn)
         ENDIF
      ENDIF
c
c     output of global parameter (Undulator field)
c
      IF (IPHSTY.LE.0) RETURN
      TITEL(1)='    Z[m]'
      TITEL(2)='    Aw' 
      TITEL(3)='    Qfld'
      if (SDDS .EQ. 0) then
         WRITE(NOUT,20) (TITEL(Iz),Iz=1,3) !Table heading
      
         Do IZ=0,NSTEPZ,IPHSTY
            WRITE(NOUT,21) IZ*DELZ*XLAMD,AWZ(IZ)
     c           ,qfld(iz)/586.
         END DO
      else
         i = 1
         do IZ=0,NSTEPZ,IPHSTY
            SDDSZValues(i) = IZ*DELZ*XLAMD
            SDDSAwValues(i) = AWZ(IZ)
            SDDSQfldValues(i) = qfld(iz)/586.
            i = i + 1
         end do
      endif
      RETURN
c
 10   FORMAT(A)
 11   FORMAT(I5,A)
 12   FORMAT(E14.4,A)
 13   FORMAT(25I2)
 20   Format((3(A14))) 
 21   Format((3(1PE14.4)))
 50   FORMAT('Size of ',a,' file [MBytes]:',i4)      
c
      END
c

      Subroutine OUTHIST(ISTEPZ,ISLICE)
c     ==================================================================
c     Output calculation results
c        - History record
c     ------------------------------------------------------------------
c
      INCLUDE  'genesis.def'
      INCLUDE  'input.cmn'
      INCLUDE  'diagnostic.cmn'
      INCLUDE  'io.cmn'
      include 'sdds.cmn'
      INCLUDE "SDDSFortran.h"
c
      INTEGER IL,islice,istepz
      REAL*8 VOUT(14+NHMAX)
c
      INTEGER i,j
      CHARACTER*30 cname,cname1,cname2,cname3
c
      IF (IPHSTY.LE.0) RETURN                      !no output at all
      IF (MOD(ISTEPZ,IPHSTY).NE.0) RETURN          !output every IPHSTYth step
      IF (MOD(ISLICE,ISHSTY).NE.0) RETURN          !output every ISHSTYth slice
c
      if (SDDS .EQ. 0) then
         DO IL=1,KOUT
            IF (IOUT(IL).EQ.1)  VOUT(IL)=GAIN
            IF (IOUT(IL).EQ.2)  VOUT(IL)=LOGP
            IF (IOUT(IL).EQ.3)  VOUT(IL)=POWMID
            IF (IOUT(IL).EQ.4)  VOUT(IL)=PHIMID
            IF (IOUT(IL).EQ.5)  VOUT(IL)=WHALF
            IF (IOUT(IL).EQ.6)  VOUT(IL)=DIVER
            IF (IOUT(IL).EQ.7)  VOUT(IL)=GAMHIST
            IF (IOUT(IL).EQ.8)  VOUT(IL)=PMODHIST(1)
            IF (IOUT(IL).EQ.9)  VOUT(IL)=XRMS
            IF (IOUT(IL).EQ.10) VOUT(IL)=YRMS
            IF (IOUT(IL).EQ.11) VOUT(IL)=ERROR
            IF (IOUT(IL).EQ.12) VOUT(IL)=XPOS
            IF (IOUT(IL).EQ.13) VOUT(IL)=YPOS
            IF (IOUT(IL).EQ.14) VOUT(IL)=DGAMHIST
            IF (IOUT(IL).EQ.15) VOUT(IL)=FFIELD
            IF (IOUT(IL).EQ.16) VOUT(IL)=PMODHIST(2)
            IF (IOUT(IL).EQ.17) VOUT(IL)=PMODHIST(3)
            IF (IOUT(IL).EQ.18) VOUT(IL)=PMODHIST(4)
            IF (IOUT(IL).EQ.19) VOUT(IL)=PMODHIST(5)
         ENDDO
         WRITE(NOUT,30) (VOUT(IL),IL=1,KOUT)
      else
         i = SDDS_Set5DoubleRowValues_F(2,ISTEPZ/IPHSTY,"Power",GAIN,
     +        "Increment",LOGP,"PowerMid",POWMID,
     +        "RealFieldMid",REALFIELDMID,"ImagFieldMid",IMAGFIELDMID)
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_Set5DoubleRowValues_F(2,ISTEPZ/IPHSTY,"PhaseMid",
     +        PHIMID,"W",WHALF,"Wp",DIVER,"Energy",GAMHIST,
     +        "Xrms",XRMS)
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_Set5DoubleRowValues_F(2,ISTEPZ/IPHSTY,
     +        "Yrms",YRMS,"Xp",XPOS,"Yp",YPOS,"Error",ERROR,
     +        "E-Spread",DGAMHIST)
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetDoubleRowValues_F(2,ISTEPZ/IPHSTY,
     +        "FarField",FFIELD)
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         do j=1,NHMAX
            write(cname,'(I1)') j
            cname1 = 'Bunching_' // cname
            cname2 = 'RealBunching_' // cname
            cname3 = 'ImagBunching_' // cname
            i = SDDS_Set3DoubleRowValues_F(2,ISTEPZ/IPHSTY,cname1,
     +           PMODHIST(j),cname2,REALPMODHIST(j),cname3,
     +           IMAGPMODHIST(j))
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if            
         enddo
      endif
c
c     Format statements
c
 30   Format((25(1PE14.4)))
c
      Return
      End     !OUTPUT
c
      Subroutine OUTHISTHEADER(ISLICE)
c     ==================================================================
c     Output calculation results
c        - History record
c     ------------------------------------------------------------------
c
      INCLUDE  'genesis.def'
      INCLUDE  'input.cmn'
      include  'particle.cmn'
      INCLUDE  'io.cmn'
      include  'sim.cmn'
      include  'magnet.cmn'
      include 'sdds.cmn'
      INCLUDE "SDDSFortran.h"
c
      INTEGER iz,islice
      CHARACTER*14 TITEL
      DIMENSION TITEL(14+NHMAX)
c
      INTEGER ITMP,I
      CHARACTER*30 SliceString, CurrentString, ScanString
c
      IF (IPHSTY.LE.0) RETURN                      !no output at all
      IF (MOD(ISLICE,ISHSTY).NE.0) RETURN          !output ISHSTYth slice
c
c     -----------------------------------------------------------------
c     Create output array for optional output
c
      TITEL(1) ='    POWER' 
      TITEL(2) ='    INCREMENT' 
      TITEL(3) ='    P_MID' 
      TITEL(4) ='    PHI_MID' 
      TITEL(5) ='    R_SIZE' 
      TITEL(6) ='    ANGLE' 
      TITEL(7) ='    ENERGY'
      TITEL(8) ='    BUNCHING'
      TITEL(9) ='    XRMS' 
      TITEL(10)='    YRMS'
      TITEL(11)='    ERROR'
      TITEL(12)='    <x>'
      TITEL(13)='    <y>'
      TITEL(14)='    E-SPREAD'
      TITEL(15)='    FAR FIELD'
      TITEL(16)='    2nd Harm'
      TITEL(17)='    3rd Harm'
      TITEL(18)='    4th Harm'
      TITEL(19)='    5th Harm'

c
c     --------------------------------------------------------------------
c     Select Output
c
      KOUT=0
      DO IZ=1,14+NHMAX
         IOUT(IZ)=0
         IF (LOUT(IZ).NE.0) THEN
            KOUT=KOUT+1 
            IOUT(KOUT)=IZ
         ENDIF
      ENDDO
c
c     ---------------------------------------------------------------------
c     Write header
c     
      Write (NLOG,5) ISLICE
c
      if (SDDS .EQ. 0) then
         if (iscan.le.0) then 
            WRITE(NOUT,10) ISLICE,XCUREN !Time dependence
         else
            WRITE(NOUT,11) ISLICE,SVALOUT !scan parameter
         endif
         WRITE(NOUT,20) (TITEL(IOUT(IZ)),IZ=1,KOUT) !Table heading
      else
         ITMP=INT(NSTEPZ/IPHSTY)+1
         i = SDDS_StartPage_F(2 , ITMP)
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         SDDSNOUTPAGESTARTED = 1
         i = SDDS_SetParameterByName_F(2,"Slice",ISLICE)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         write(SliceString,'(I4)') ISLICE
         SliceString = 'Slice = ' // SliceString
         i = SDDS_SetParameterStringByName_F(2,"SliceString",
     +        SliceString)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         if (iscan.le.0) then 
            i = SDDS_SetParameterByName_F(2,"Current",XCUREN)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            write(CurrentString,'(F8.2)') XCUREN
            CurrentString = 'Current = ' // CurrentString
            i = SDDS_SetParameterStringByName_F(2,"CurrentString",
     +           CurrentString)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         else
            i = SDDS_SetParameterByName_F(2,"ScanValue",SVALOUT)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            write(ScanString,'(F8.2)') SVALOUT
            ScanString = 'Scan Value = ' // ScanString
            i = SDDS_SetParameterStringByName_F(2,"ScanValueString",
     +           ScanString)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         endif
         i = SDDS_SetColumnByName_F(2,SDDSZValues,ITMP,"Z")
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetColumnByName_F(2,SDDSAwValues,ITMP,"Aw")
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetColumnByName_F(2,SDDSQfldValues,ITMP,"Qfld")
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
      endif
c
c     Format statements
c     ------------------------------------------------------------------
 5    FORMAT('***  Writing history record for slice ',I5)
 10   Format(/'********** OUTPUT: SLICE ',I5/
     F          5X,'      ================='/
     F       1X,1PE14.4,' Current'//)
 11   Format(/'********** OUTPUT: SLICE ',I5/
     F          5X,'      ================='/
     F       1X,1PE14.4,' Scan Value'//)
 20   Format((25(A14))) 
c
      Return
      End     !OUTPUTHEADER
c
c
c
      SUBROUTINE OUTPART(istepz,islice,xkper0)
c     ==================================================================
c     Output of global parameter (t-independend): 
c     z, wiggler field
c     ------------------------------------------------------------------
c
      INCLUDE  'genesis.def'
      INCLUDE  'io.cmn'
      INCLUDE  'particle.cmn'
      INCLUDE  'input.cmn'
      INCLUDE  'work.cmn'
      include 'sdds.cmn'
      INCLUDE "SDDSFortran.h"
c
      INTEGER iz,istepz,islice
      REAL*8  xkper0
c
      INTEGER i
      DIMENSION cNamesD(8)
      CHARACTER*30 cNamesD
      DIMENSION XpartValues(NPART),YpartValues(NPART),ZPhase(NPART)
      REAL*8 XpartValues, YpartValues, ZPhase
      CHARACTER*30 zString
c
c     ------------------------------------------------------------------ 
c     output of t independent values with first slice
c
      IF ((IPPART.LE.0).OR.(ISPART.LE.0)) RETURN   !no output at all
      IF (MOD(ISTEPZ,IPPART).NE.0) RETURN          !output IPPARTth step
      IF (MOD(ISLICE,ISPART).NE.0) RETURN          !output ISPARTth slice
c
      IF (ISTEPZ.EQ.0) CALL RPOS(0,XPART,YPART)
      CALL GETPSI(P1)
      if (SDDS .EQ. 0) then
         WRITE(NPAR,REC=IRECPAR) (GAMMA(IZ),IZ=1,NPART)
         WRITE(NPAR,REC=IRECPAR+1) (P1(IZ),IZ=1,NPART)
         WRITE(NPAR,REC=IRECPAR+2) (XPART(IZ)/XKPER0,IZ=1,NPART)
         WRITE(NPAR,REC=IRECPAR+3) (YPART(IZ)/XKPER0,IZ=1,NPART)
         WRITE(NPAR,REC=IRECPAR+4) (PX(IZ),IZ=1,NPART)
         WRITE(NPAR,REC=IRECPAR+5) (PY(IZ),IZ=1,NPART)
      else
         cNamesD(1) = "Energy"
         cNamesD(2) = "Phase"
         cNamesD(3) = "XPosition"
         cNamesD(4) = "YPosition"
         cNamesD(5) = "XMomentum"
         cNamesD(6) = "YMomentum"
         cNamesD(7) = "ZPhase"
         cNamesD(8) = "Theta"
c
         i = SDDS_StartPage_F(3 , NPART)
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetParameterByName_F(3,"Slice",ISLICE)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetParameterByName_F(3,"Z",SDDSZValues(ISTEPZ+1))
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetParameterByName_F(3,"Current",XCUREN)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         write(zString,'(F8.4)') SDDSZValues(ISTEPZ+1)
         zString = 'z = ' // zString
         i = SDDS_SetParameterStringByName_F(3,"Zstring",zString)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetColumnByName_F(3,GAMMA,NPART,cNamesD(1))
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetColumnByName_F(3,P1,NPART,cNamesD(2))
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         do i = 1,NPART
            XpartValues(i) = XPART(i)/XKPER0
            YpartValues(i) = YPART(i)/XKPER0
            ZPhase(i) = P1(i) * XLAMDS / TWOPI
         end do
         i = SDDS_SetColumnByName_F(3,XpartValues,NPART,cNamesD(3))
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetColumnByName_F(3,YpartValues,NPART,cNamesD(4))
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetColumnByName_F(3,PX,NPART,cNamesD(5))
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetColumnByName_F(3,PY,NPART,cNamesD(6))
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetColumnByName_F(3,ZPhase,NPART,cNamesD(7))
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetColumnByName_F(3,THETA,NPART,cNamesD(8))
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_WritePage_F(3)
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
      endif
      IRECPAR=IRECPAR+6
      RETURN
      END
c
c
c
      SUBROUTINE status(istepz,islice)
c     ==================================================================
c     Let user know % complete at every 10%.
c     ------------------------------------------------------------------
c
      INCLUDE 'genesis.def'
      INCLUDE 'input.cmn'
      INCLUDE 'io.cmn'
c
      integer istepz,islice
      REAL*8 xPER,yPER
c
      xPer=100.d0*float(ISTEPZ)*DELZ*XLAMD/ZSTOP
      yPer=100.d0*float(ISTEPZ-1)*DELZ*XLAMD/ZSTOP
      If (Mod(xPer,10.0d0).LT.Mod(yper,10.0d0)) 
     +       Write (NLOG,20) ISLICE,Int(xper)
   20 Format ('Slice ', I5,': Simulation ',I3,'% completed.')
c
      Return
      END     !Status
c
c
c
      SUBROUTINE OUTFIELD(istepz,islice,xkper0)
c     ==================================================================
c     dump fieldarray  
c     ------------------------------------------------------------------
c
      include 'genesis.def'
      include 'input.cmn'
      include 'io.cmn'
      include 'field.cmn'
      include 'work.cmn'
      include 'sdds.cmn'
      INCLUDE "SDDSFortran.h"
c
      INTEGER I,islice,istepz
      REAL*8 SCLTMP,xkper0
c
      DIMENSION column1(NCAR*NCAR)
      DIMENSION column2(NCAR*NCAR)
      DIMENSION column3(NCAR*NCAR)
      DIMENSION column4(NCTMP*NCTMP)
      DIMENSION column5(NCTMP*NCTMP)
      DIMENSION column6(NCTMP*NCTMP)
      REAL*8 column1,column2,column3
      REAL*8 column4,column5,column6
      CHARACTER*30 zString
c
      IF ((IPRADI.LE.0).OR.(ISRADI.LE.0)) RETURN   !no output at all
      IF (MOD(ISTEPZ,IPRADI).NE.0) RETURN          !output IPRADIth step
      IF (MOD(ISLICE,ISRADI).NE.0) RETURN          !output ISRADIth slice
c
      SCLTMP=DXY*EEV*XKPER0/XKS/DSQRT(VACIMP)   !
      if (SDDS .EQ. 0) then
         write(NFLD,REC=IRECFLD) (SCLTMP* DBLE(CRFIELD(I)),I=1,
     +        NCAR*NCAR)
         write(NFLD,REC=IRECFLD+1) 
     +        (SCLTMP*DIMAG(CRFIELD(I)),I=1,NCAR*NCAR)
      else
         if (SDDSNFLDSTARTED .EQ. 0) then
            SDDSNFLDSTARTED = 1
            i = SDDS_DefineParameter1_F(4,"xInterval","","","","",
     +           SDDS_DOUBLE,DXY/XKPER0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter1_F(4,"yInterval","","","","",
     +           SDDS_DOUBLE,DXY/XKPER0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter1_F(4,"xMinimum","","","","",
     +           SDDS_DOUBLE,-DGRID*XKPER0/XKPER0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter1_F(4,"yMinimum","","","","",
     +           SDDS_DOUBLE,-DGRID*XKPER0/XKPER0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter1_F(4,"xDimension","","","","",
     +           SDDS_LONG,NCAR)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter1_F(4,"yDimension","","","","",
     +           SDDS_LONG,NCAR)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter_F(4,"Slice","","","Slice Number",
     +           "",SDDS_LONG,"")
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter_F(4,"Z","","m","","",
     +           SDDS_DOUBLE,"")
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineParameter_F(4,"Zstring","","m","","",
     +           SDDS_STRING,"")
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
c     
            i = SDDS_WriteLayout_F(4)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            if (LOUT(6).NE.0) then
               NCTMP = 2**(INT(log(float(NCAR))/log(2.))+1)
               i = SDDS_DefineParameter1_F(8,"xInterval","","","","",
     +              SDDS_DOUBLE,XLAMDS/((DXY/XKPER0) * 2 * PI * NCTMP))
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
               i = SDDS_DefineParameter1_F(8,"yInterval","","","","",
     +              SDDS_DOUBLE,XLAMDS/((DXY/XKPER0) * 2 * PI * NCTMP))
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
               i = SDDS_DefineParameter1_F(8,"xMinimum","","","","",
     +              SDDS_DOUBLE,-XLAMDS/((DXY/XKPER0) * 4 * PI))
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
               i = SDDS_DefineParameter1_F(8,"yMinimum","","","","",
     +              SDDS_DOUBLE,-XLAMDS/((DXY/XKPER0) * 4 * PI))
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
               i = SDDS_DefineParameter1_F(8,"xDimension","","","","",
     +              SDDS_LONG,NCTMP)
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
               i = SDDS_DefineParameter1_F(8,"yDimension","","","","",
     +              SDDS_LONG,NCTMP)
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
               i = SDDS_DefineParameter_F(8,"Slice","","","Slice Number"
     +              ,"",SDDS_LONG,"")
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
               i = SDDS_DefineParameter_F(8,"Z","","m","","",
     +              SDDS_DOUBLE,"")
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
               i = SDDS_DefineParameter_F(8,"Zstring","","m","","",
     +              SDDS_STRING,"")
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
c     
               i = SDDS_WriteLayout_F(8)
               if (i .NE. 1) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
            end if
c
         endif
         do i = 1,NCAR*NCAR
            column1(i) = SCLTMP * DBLE(CRFIELD(I))
            column2(i) = SCLTMP * DIMAG(CRFIELD(I))
            column3(i) = column1(i)**2 + column2(i)**2
         end do
         i = SDDS_StartPage_F(4 , NCAR*NCAR)
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetParameterByName_F(4,"Slice",ISLICE)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetParameterByName_F(4,"Z",SDDSZValues(ISTEPZ+1))
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         write(zString,'(F8.4)') SDDSZValues(ISTEPZ+1)
         zString = 'z = ' // zString
         i = SDDS_SetParameterStringByName_F(4,"Zstring",zString)
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetColumnByName_F(4,column1,NCAR*NCAR,
     +        "ReA")
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetColumnByName_F(4,column2,NCAR*NCAR,
     +        "ImA")
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetColumnByName_F(4,column3,NCAR*NCAR,
     +        "Power")
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_WritePage_F(4)
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         if (LOUT(6).NE.0) then
            do i = 1,NCTMP*NCTMP
               column4(i) = SCLTMP * DBLE(CRWORK3(i))
               column5(i) = SCLTMP * DIMAG(CRWORK3(i))
               column6(i) = column4(i)**2 + column5(i)**2
            end do
            i = SDDS_StartPage_F(8 , NCTMP*NCTMP)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetParameterByName_F(8,"Slice",ISLICE)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetParameterByName_F(8,"Z",SDDSZValues(ISTEPZ+1))
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            write(zString,'(F8.4)') SDDSZValues(ISTEPZ+1)
            zString = 'z = ' // zString
            i = SDDS_SetParameterStringByName_F(8,"Zstring",zString)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetColumnByName_F(8,column4,NCTMP*NCTMP,
     +           "ReA")
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetColumnByName_F(8,column5,NCTMP*NCTMP,
     +           "ImA")
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetColumnByName_F(8,column6,NCTMP*NCTMP,
     +           "Power")
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_WritePage_F(8)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         end if
c     
      endif
      IRECFLD=IRECFLD+2
c
      return
      end
c
c
      SUBROUTINE OUTDUMP(ISLICE,xkper0)
c     ====================================================================
c     dump complete field array for future use
c     --------------------------------------------------------------------
c
      include 'genesis.def'
      include 'field.cmn'
      include 'timerec.cmn'
      include 'io.cmn'
      include 'work.cmn'
      include 'input.cmn'
      include 'time.cmn'
      include 'particle.cmn'
      include 'sdds.cmn'
      INCLUDE "SDDSFortran.h"
c
      INTEGER I,I0,J,islice
      REAL*8  XKPER0
c
      INTEGER istepz
      DIMENSION column1(NCAR*NCAR), column2(NCAR*NCAR)
      REAL*8 column1, column2
      DIMENSION cNamesD(8)
      CHARACTER*30 cNamesD
      DIMENSION XpartValues(NPART),YpartValues(NPART),ZPhase(NPART)
      REAL*8 XpartValues, YpartValues, ZPhase
      CHARACTER*30 zString
c
c     particle distribution
c
      if (idmppar.ne.0) then
         if (SDDS .EQ. 0) then
            j=6*(ISLICE-1)+1 
            WRITE(NDMP2,REC=j)   (GAMMA(I),I=1,NPART)
            WRITE(NDMP2,REC=j+1) (THETA(I),I=1,NPART)
            WRITE(NDMP2,REC=j+2) (XPART(I)/XKPER0,I=1,NPART)
            WRITE(NDMP2,REC=j+3) (YPART(I)/XKPER0,I=1,NPART)
            WRITE(NDMP2,REC=j+4) (PX(I),I=1,NPART)
            WRITE(NDMP2,REC=j+5) (PY(I),I=1,NPART)
         else
            cNamesD(1) = "Energy"
            cNamesD(2) = "Phase"
            cNamesD(3) = "XPosition"
            cNamesD(4) = "YPosition"
            cNamesD(5) = "XMomentum"
            cNamesD(6) = "YMomentum"
            cNamesD(7) = "ZPhase"
            cNamesD(8) = "Theta"
c     
            i = SDDS_StartPage_F(9 , NPART)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetParameterByName_F(9,"Slice",ISLICE)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetParameterByName_F(9,"Z",SDDSZValues(ISTEPZ+1))
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetParameterByName_F(9,"Current",XCUREN)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            write(zString,'(F8.4)') SDDSZValues(ISTEPZ+1)
            zString = 'z = ' // zString
            i = SDDS_SetParameterStringByName_F(9,"Zstring",zString)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetColumnByName_F(9,GAMMA,NPART,cNamesD(1))
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetColumnByName_F(9,P1,NPART,cNamesD(2))
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            do i = 1,NPART
               XpartValues(i) = XPART(i)/XKPER0
               YpartValues(i) = YPART(i)/XKPER0
               ZPhase(i) = P1(i) * XLAMDS / TWOPI
            end do
            i = SDDS_SetColumnByName_F(9,XpartValues,NPART,cNamesD(3))
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetColumnByName_F(9,YpartValues,NPART,cNamesD(4))
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetColumnByName_F(9,PX,NPART,cNamesD(5))
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetColumnByName_F(9,PY,NPART,cNamesD(6))
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetColumnByName_F(9,ZPhase,NPART,cNamesD(7))
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetColumnByName_F(9,THETA,NPART,cNamesD(8))
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_WritePage_F(9)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         endif
      endif
c
c     field distribution
c
      if (idmpfld.eq.0) return     
c
      IF (ITDP.EQ.0) THEN    !time-independent stuff (s.s + scan)
         DO i=1,NCAR*NCAR
            CRWORK2(i)=CRFIELD(i)
         ENDDO
         if (SDDS .EQ. 0) then
            WRITE(NDUMP,REC=islice) (CRWORK2(i),i=1,NCAR*NCAR)
         else
            do i = 1,NCAR*NCAR
               column1(i) = DBLE(CRWORK2(i))
               column2(i) = DIMAG(CRWORK2(i))
            end do
            i = SDDS_StartPage_F(5 , NCAR*NCAR)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetColumnByName_F(5,column1,NCAR*NCAR,
     +           "ReA")
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_SetColumnByName_F(5,column2,NCAR*NCAR,
     +           "ImA")
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_WritePage_F(5)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         endif
         RETURN
      ENDIF
c
      I0=(NSLP-1)*NCAR*NCAR
      CALL PULLTIMEREC(CRWORK3,ncar,NSLP-1)
      DO i=1,NCAR*NCAR
         CRWORK2(i)=CRWORK3(i)
      ENDDO
      if (SDDS .EQ. 0) then
         WRITE(NDUMP,REC=ISLICE) (CRWORK2(i),i=1,NCAR*NCAR)
      else
         do i = 1,NCAR*NCAR
            column1(i) = DBLE(CRWORK2(i))
            column2(i) = DIMAG(CRWORK2(i))
         end do
         i = SDDS_StartPage_F(5 , NCAR*NCAR)
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetColumnByName_F(5,column1,NCAR*NCAR,
     +        "ReA")
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_SetColumnByName_F(5,column2,NCAR*NCAR,
     +        "ImA")
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         i = SDDS_WritePage_F(5)
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
      endif
c
      IF (ISLICE.LT.NSLICE) RETURN 
c
      DO j=NSLP-2,0,-1
        CALL PULLTIMEREC(CRWORK3,ncar,j)
        DO i=1,NCAR*NCAR
           CRWORK2(i)=CRWORK3(i)
        ENDDO
        i0=nslice+nslp-1-j
        if (SDDS .EQ. 0) then
           WRITE(NDUMP,REC=i0) (CRWORK2(i),i=1,NCAR*NCAR)
        else
           do i = 1,NCAR*NCAR
              column1(i) = DBLE(CRWORK2(i))
              column2(i) = DIMAG(CRWORK2(i))
           end do
           i = SDDS_StartPage_F(5 , NCAR*NCAR)
           if (i .NE. 1) then
              call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
              stop 1
           end if
           i = SDDS_SetColumnByName_F(5,column1,NCAR*NCAR,
     +          "ReA")
           if (i .NE. 1) then
              call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
              stop 1
           end if
           i = SDDS_SetColumnByName_F(5,column2,NCAR*NCAR,
     +          "ImA")
           if (i .NE. 1) then
              call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
              stop 1
           end if
           i = SDDS_WritePage_F(5)
           if (i .NE. 1) then
              call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
              stop 1
           end if
        endif
      enddo
      RETURN
      END
c
      SUBROUTINE CLOSEFILE(NIO)
c     =================================================================
c     closing file
c     ---------------------------------------------------------------
c
      LOGICAL ISOP
c
      if (NIO.gt.6) then
        INQUIRE(NIO,OPENED=ISOP) 
        IF (ISOP) close(NIO)                   !close history file
      ENDIF  
      RETURN
      END ! of closefile
c
      FUNCTION OPENTEXTFILE(file,status,NIO)
c     ==================================================================
c     open ascii file (sequential access)
c     ------------------------------------------------------------------ 
c    
c
      include 'genesis.def'
c
      character*(*) file,status
      integer NIO



      OPENTEXTFILE=NIO
      OPEN(NIO,FILE=file,status=status,ERR=100)
      RETURN
 100  OPENTEXTFILE=PRINTERR(ERROPEN,file)
      RETURN
      end ! of opentextfile


      FUNCTION OPENBINFILE(root,extension,NIO,nsize)
c     ==================================================================
c     open binary file (direct access) as addition output file
c     ------------------------------------------------------------------ 
c    
c
      include 'genesis.def'
      include 'input.cmn'
      include 'sdds.cmn'
      INCLUDE "SDDSFortran.h"
c
      character*30 root
      character*3  extension
      character*36 filename
      integer NIO,nsize,j
c
      INTEGER i
c
      openbinfile=NIO
      j=INDEX(root,' ')
      if (j.eq.0) j=31
      j=j-1
      filename=root(1:j)//'.'//extension
      if (SDDS .EQ. 1) then
         if (extension .eq. 'fld') then
            i = SDDS_InitializeOutput_F(4,SDDS_BINARY,1,
     +           "GENESIS Field File",
     +           "",filename)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            call DEFINESDDSPARAMETERS(4)
            i = SDDS_DefineColumn_F(4,"ReA","Real Radiation Field","",
     +           "","",SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(4,"ImA","Imaginary Radiation Field",
     +           "","","",SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(4,"Power","Power","a.u.","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            if (LOUT(6).NE.0) then
               filename=root(1:j)//'.ver'
               i = SDDS_InitializeOutput_F(8,SDDS_BINARY,1,
     +              "GENESIS Vertual Space Field File",
     +              "",filename)
               if (i .NE. 1) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
               call DEFINESDDSPARAMETERS(8)
               i = SDDS_DefineColumn_F(8,"ReA","Real Radiation Field",
     +              "","","",SDDS_DOUBLE,0)
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
               i = SDDS_DefineColumn_F(8,"ImA",
     +              "Imaginary Radiation Field","","","",SDDS_DOUBLE,0)
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
               i = SDDS_DefineColumn_F(8,"Power","Power","a.u.","","",
     +              SDDS_DOUBLE,0)
               if (i .LT. 0) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
            endif
         elseif (extension .eq. 'par') then
            i = SDDS_InitializeOutput_F(3,SDDS_BINARY,1,
     +           "GENESIS Particle File",
     +           "",filename)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            call DEFINESDDSPARAMETERS(3)
            i = SDDS_DefineColumn_F(3,"Energy","","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(3,"Phase","Total Phase","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(3,"XPosition","","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(3,"YPosition","","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(3,"XMomentum","","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(3,"YMomentum","","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(3,"ZPhase","","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(3,"Theta","Particle Phase","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         elseif (extension .eq. 'dpa') then
            i = SDDS_InitializeOutput_F(9,SDDS_BINARY,1,
     +           "GENESIS Particle Dump File",
     +           "",filename)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            call DEFINESDDSPARAMETERS(9)
            i = SDDS_DefineColumn_F(9,"Energy","","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(9,"Phase","Total Phase","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(9,"XPosition","","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(9,"YPosition","","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(9,"XMomentum","","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(9,"YMomentum","","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(9,"ZPhase","","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(9,"Theta","Particle Phase","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         elseif (extension .eq. 'dfl') then
            i = SDDS_InitializeOutput_F(5,SDDS_BINARY,1,
     +           "GENESIS Simulation Dump File",
     +           "",filename)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_DefineColumn_F(5,"ReA","","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if          
            i = SDDS_DefineColumn_F(5,"ImA","","","","",
     +           SDDS_DOUBLE,0)
            if (i .LT. 0) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            i = SDDS_WriteLayout_F(5)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         else
            OPEN(NIO,FILE=filename,status='unknown',ACCESS='DIRECT',
     +           RECL=nsize,ERR=100)
         endif
      else
         OPEN(NIO,FILE=filename,status='unknown',ACCESS='DIRECT',
     +        RECL=nsize,ERR=100)
      endif
      RETURN
 100  openbinfile=PRINTERR(ERROPEN,filename)
      RETURN
      end ! of openbinfile
c
c

      Subroutine FIRST
c     ============================================
c     initial information for user
c     --------------------------------------------
c
      include 'genesis.def'
      include 'io.cmn'
c 
      write(NLOG,100) GENVER,PLATF
      return

 100  Format('-------------------------------',/,
     c       'GENESIS 1.3 HAS BEGUN EXECUTION',/,
     c       '(Version ',f3.1,' ',a,')',/)
      end


      Subroutine LAST
c     ==================================================================
c     Called at end of run.
c     Closes all files, which must stay open during the run
c     ------------------------------------------------------------------
c
      INCLUDE 'genesis.def'
      INCLUDE 'io.cmn'
      INCLUDE 'input.cmn'
      include 'sdds.cmn'
      INCLUDE "SDDSFortran.h"
c     
      INTEGER i
c
      Write (NLOG,100)
      if (SDDS .EQ. 0) then
         CALL CLOSEFILE(NOUT)   !standard output
         CALL CLOSEFILE(NFLD)   !field output
         CALL CLOSEFILE(NPAR)   !particle output 
         CALL CLOSEFILE(NDUMP)  !dumped field
         CALL CLOSEFILE(NPIN)   !particle input
         CALL CLOSEFILE(NFIN)   !field input
         CALL CLOSEFILE(NDMP2)  !dumped particle 
      else
         i = SDDS_Terminate_F(2)
         if (i .NE. 1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         if (IPRADI.GT.0) then
            i = SDDS_Terminate_F(4)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            if (LOUT(6).NE.0) then
               i = SDDS_Terminate_F(8)
               if (i .NE. 1) then
                  call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
                  stop 1
               end if
            end if
         endif
         if (IPPART.GT.0) then
            i = SDDS_Terminate_F(3)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         endif
         if (IDMPFLD.ne.0) then
            i = SDDS_Terminate_F(5)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         endif
         if (NPIN .NE. -1) then
            i = SDDS_Terminate_F(6)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         endif
         if (NFIN .NE. -1) then
            i = SDDS_Terminate_F(1)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         endif
         if (IDMPPAR.NE.0) then
            i = SDDS_Terminate_F(9)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
         endif
      endif
      CALL CLOSEFILE(NDIS)   !input distribution
      CALL CLOSETIMEREC
c      
      Write (NLOG,200) !genesis has finished
c
      if (nlog.ne.6)  CALL CLOSEFILE(NLOG)   !log file
      stop
c
 100  FORMAT('***  Closing files')
 200  FORMAT(/,'GENESIS RUN HAS FINISHED',/,
     c         '------------------------') 
      End     !LAST
c

      FUNCTION PRINTERR(ierr,text)
c     ========================================================
c     print error messages
c     --------------------------------------------------------
      
      include 'genesis.def'
      include 'io.cmn'

      integer ierr
      character*(*) text

      PRINTERR=ierr
      if (ierr.GE.0) RETURN
      GOTO (10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,
     c      25,26,27,28,29,30)
     c     ,iabs(ierr)
 10   WRITE(NLOG,100) text
      RETURN
 11   WRITE(NLOG,101) text
      RETURN
 12   WRITE(NLOG,102) text
      RETURN
 13   WRITE(NLOG,103) text
      RETURN
 14   WRITE(NLOG,104) text
      RETURN
 15   WRITE(NLOG,105) text
      RETURN
 16   WRITE(NLOG,106) text
      RETURN
 17   WRITE(NLOG,107) text
      RETURN
 18   WRITE(NLOG,108) text
      RETURN
 19   WRITE(NLOG,109) text
      RETURN
 20   WRITE(NLOG,110) text
      RETURN
 21   WRITE(NLOG,111) text
      RETURN
 22   WRITE(NLOG,112) text
      RETURN
 23   WRITE(NLOG,113) text
      RETURN
 24   WRITE(NLOG,114) text
      RETURN
 25   WRITE(NLOG,115) text
      RETURN
 26   WRITE(NLOG,116) text
      RETURN
 27   WRITE(NLOG,117) text
      RETURN
 28   WRITE(NLOG,118) text
      RETURN
 29   WRITE(NLOG,119) text
      RETURN
 30   WRITE(NLOG,120) text
      RETURN
c
c     FORMAT statements
c
 100  FORMAT('***  FILE-ERROR: ',a,/,
     c       '***  Cannot be opened')
 101  FORMAT('***  FILE-ERROR: ',a,/,
     c       '***  Cannot be accessed')
 102  FORMAT('***  FILE-ERROR: ',a,/,
     c       '***  Cannot be opened',/,
     c       '***  Creating template file: template.in')
 103  FORMAT('***  FILE-ERROR: ',a,/,
     c       '***  Error in namelise $NEWRUN')
 104  FORMAT('***  SCAN-WARNING: Conflict with ITDP',/,
     c       '***  Using SCAN-Feature',a)
 105  FORMAT('***  SCAN-WARNING: Conflict with BEAMFILE',/,
     c       '***  Ignoring BEAMFILE: ',a)
 106  FORMAT('***  BEAMFILE-WARNING: Size exceeds NSMAX',/,
     c       '***  ',a)
 107  FORMAT('***  INPUT-ERROR: ',a)
 108  FORMAT('***  INPUT-WARNING: ',a)
 109  FORMAT('***  INPUT-ERROR: Cannot convert to individiual input',/,
     c       '***  ',a)
 110  FORMAT('***  NUMERICAL-ERROR: Boundary exceeded of',a,/,
     c       '***  Ignoring exceeding elements')
 111  FORMAT('***  ROUND-WARNING: Section not multiple of XLAMD',/,
     c       '***  MAGINFILE:',a)    
 112  FORMAT('***  EXTRAPOLATION-WARNING: Exceeding time window of',/,
     c       '***  BEAMFILE by:',a)
 113  FORMAT('***  SCAN-ERROR: Conflict with MAGINFILE:',a,/,
     c       '***  Disabling SCAN-feature') 
 114  FORMAT('***  SCAN-ERROR: Conflict with MAGOUTFILE:',a,/,
     c       '***  Disabling SCAN-feature')
 115  FORMAT('***  WARNING: Particle loss of ',a,'%')
 116  FORMAT('***  WARNING: External magnet definition too short for '
     c       ,a)
 117  FORMAT('***  ERROR: Invalid filename:',a)
 118  FORMAT('***  FILE-ERROR: Cannot read from FIELDFILE:',a)
 119  FORMAT('***  WARNING: ',a)
 120  FORMAT('***  ERROR: Cannot run in background mode.',/,
     c       '***  Information needed for ',a)
      END

      SUBROUTINE WRITENOUT
c     =============================================
c     writes the SDDS page to disk
c     ---------------------------------------------
c
      include 'genesis.def'
      include 'sdds.cmn'
      INCLUDE "SDDSFortran.h"
c
      INTEGER i
c
      if (SDDS .EQ. 1) then
         if (SDDSNOUTPAGESTARTED .eq. 1) then
            i = SDDS_WritePage_F(2)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            SDDSNOUTPAGESTARTED = 0
         endif
      endif
c
      RETURN
      END

      SUBROUTINE DEFINESDDSPARAMETERS(FILEINDEX)
c     =============================================
c     define common sdds parameters
c     ---------------------------------------------
c
      include 'genesis.def'
      include 'input.cmn'
      include 'sdds.cmn'
      INCLUDE "SDDSFortran.h"
c
      INTEGER i, j, fileindex
      CHARACTER*30 pname
      DIMENSION pNamesS(2)
      CHARACTER*30 pNamesS
      DIMENSION pValuesS(2)
      CHARACTER*30 pValuesS
      DIMENSION pNamesD(49)
      CHARACTER*30 pNamesD
      DIMENSION pValuesD(49)
      REAL*8 pValuesD
      DIMENSION pNamesL(58)
      CHARACTER*30 pNamesL
      DIMENSION pValuesL(58)
      INTEGER pValuesL
c
      pNamesS(1) = "InputFile"
      pValuesS(1) = inputfile
      pNamesS(2) = "OutputFile"
      pValuesS(2) = outputfile
      
      pNamesD(1) = "AW0"
      pValuesD(1) = AW0
      pNamesD(2) = "XKX"
      pValuesD(2) = XKX
      pNamesD(3) = "XKY"
      pValuesD(3) = XKY
      pNamesD(4) = "WCOEFZ_1"
      pValuesD(4) = WCOEFZ(1)
      pNamesD(5) = "WCOEFZ_2"
      pValuesD(5) = WCOEFZ(2)
      pNamesD(6) = "WCOEFZ_3"
      pValuesD(6) = WCOEFZ(3)
      pNamesD(7) = "XLAMD"
      pValuesD(7) = XLAMD
      pNamesD(8) = "FBESS0"
      pValuesD(8) = FBESS0
      pNamesD(9) = "DELAW"
      pValuesD(9) = DELAW
      pNamesD(10) = "AWD"
      pValuesD(10) = AWD
      pNamesD(11) = "GAMMA0"
      pValuesD(11) = GAMMA0
      pNamesD(12) = "DELGAM"
      pValuesD(12) = DELGAM
      pNamesD(13) = "RXBEAM"
      pValuesD(13) = RXBEAM
      pNamesD(14) = "RYBEAM"
      pValuesD(14) = RYBEAM
      pNamesD(15) = "ALPHAX"
      pValuesD(15) = ALPHAX
      pNamesD(16) = "ALPHAY"
      pValuesD(16) = ALPHAY
      pNamesD(17) = "EMITX"
      pValuesD(17) = EMITX
      pNamesD(18) = "EMITY"
      pValuesD(18) = EMITY
      pNamesD(19) = "XBEAM"
      pValuesD(19) = XBEAM
      pNamesD(20) = "YBEAM"
      pValuesD(20) = YBEAM
      pNamesD(21) = "PXBEAM"
      pValuesD(21) = PXBEAM
      pNamesD(22) = "PYBEAM"
      pValuesD(22) = PYBEAM
      pNamesD(23) = "XLAMDS"
      pValuesD(23) = XLAMDS
      pNamesD(24) = "PRAD0"
      pValuesD(24) = PRAD0
      pNamesD(25) = "ZRAYL"
      pValuesD(25) = ZRAYL
      pNamesD(26) = "ZWAIST"
      pValuesD(26) = ZWAIST
      pNamesD(27) = "RMAX0"
      pValuesD(27) = RMAX0
      pNamesD(28) = "ZSEP"
      pValuesD(28) = ZSEP
      pNamesD(29) = "DELZ"
      pValuesD(29) = DELZ
      pNamesD(30) = "ZSTOP"
      pValuesD(30) = ZSTOP
      pNamesD(31) = "QUADF"
      pValuesD(31) = QUADF
      pNamesD(32) = "QUADD"
      pValuesD(32) = QUADD
      pNamesD(33) = "FL"
      pValuesD(33) = FL
      pNamesD(34) = "DL"
      pValuesD(34) = DL
      pNamesD(35) = "DRL"
      pValuesD(35) = DRL
      pNamesD(36) = "F1ST"
      pValuesD(36) = F1ST
      pNamesD(37) = "QFDX"
      pValuesD(37) = QFDX
      pNamesD(38) = "QFDY"
      pValuesD(38) = QFDY
      pNamesD(39) = "CURPEAK"
      pValuesD(39) = CURPEAK
      pNamesD(40) = "CURLEN"
      pValuesD(40) = CURLEN
      pNamesD(41) = "SHOTNOISE"
      pValuesD(41) = SHOTNOISE
      pNamesD(42) = "SVAR"
      pValuesD(42) = SVAR
      pNamesD(43) = "DGRID"
      pValuesD(43) = DGRID
      pNamesD(44) = "SOLEN"
      pValuesD(44) = SOLEN
      pNamesD(45) = "SL"
      pValuesD(45) = SL
      pNamesD(46) = "CUTTAIL"
      pValuesD(46) = CUTTAIL
      pNamesD(47) = "ELOSS"
      pValuesD(47) = ELOSS
      pNamesD(48) = "VERSION"
      pValuesD(48) = VERSION
      pNamesD(49) = "CHARGE"
      pValuesD(49) = CHARGE
c     
      pNamesL(1) = "IERTYP"
      pValuesL(1) = IERTYP
      pNamesL(2) = "IWITYP"
      pValuesL(2) = IWITYP
      pNamesL(3) = "ISEED"
      pValuesL(3) = ISEED
      pNamesL(4) = "NPART"
      pValuesL(4) = NPART
      pNamesL(5) = "NCAR"
      pValuesL(5) = NCAR
      pNamesL(6) = "LBC"
      pValuesL(6) = LBC
      pNamesL(7) = "NSCR"
      pValuesL(7) = NSCR
      pNamesL(8) = "NSCZ"
      pValuesL(8) = NSCZ
      pNamesL(9) = "NPTR"
      pValuesL(9) = NPTR
      pNamesL(10) = "NWIG"
      pValuesL(10) = NWIG
      pNamesL(11) = "NSEC"
      pValuesL(11) = NSEC
      pNamesL(12) = "IORB"
      pValuesL(12) = IORB
      pNamesL(13) = "MAGIN"
      pValuesL(13) = MAGIN
      pNamesL(14) = "MAGOUT"
      pValuesL(14) = MAGOUT
      pNamesL(15) = "ILDGAM"
      pValuesL(15) = ILDGAM
      pNamesL(16) = "ILDPSI"
      pValuesL(16) = ILDPSI
      pNamesL(17) = "ILDX"
      pValuesL(17) = ILDX
      pNamesL(18) = "ILDY"
      pValuesL(18) = ILDY
      pNamesL(19) = "ILDPX"
      pValuesL(19) = ILDPX
      pNamesL(20) = "ILDPY"
      pValuesL(20) = ILDPY
      pNamesL(21) = "ITGAUS"
      pValuesL(21) = ITGAUS
      pNamesL(22) = "IPHSTY"
      pValuesL(22) = IPHSTY
      pNamesL(23) = "ISHSTY"
      pValuesL(23) = ISHSTY
      pNamesL(24) = "IPPART"
      pValuesL(24) = IPPART
      pNamesL(25) = "ISPART"
      pValuesL(25) = ISPART
      pNamesL(26) = "IPRADI"
      pValuesL(26) = IPRADI
      pNamesL(27) = "ISRADI"
      pValuesL(27) = ISRADI
      pNamesL(28) = "IDUMP"
      pValuesL(28) = IDUMP
      pNamesL(29) = "IOTAIL"
      pValuesL(29) = IOTAIL
      pNamesL(30) = "NTAIL"
      pValuesL(30) = NTAIL
      pNamesL(31) = "NSLICE"
      pValuesL(31) = NSLICE
      pNamesL(32) = "IALL"
      pValuesL(32) = IALL
      pNamesL(33) = "ITDP"
      pValuesL(33) = ITDP
      pNamesL(34) = "IPSEED"
      pValuesL(34) = IPSEED
      pNamesL(35) = "ISCAN"
      pValuesL(35) = ISCAN
      pNamesL(36) = "NSCAN"
      pValuesL(36) = NSCAN
      pNamesL(37) = "NBINS"
      pValuesL(37) = NBINS
      pNamesL(38) = "NHARM"
      pValuesL(38) = NHARM
      pNamesL(39) = "ISRAVG"
      pValuesL(39) = ISRAVG
      pNamesL(40) = "ISRSIG"
      pValuesD(40) = ISRSIG
      pNamesL(41) = "NDCUT"
      pValuesD(41) = NDCUT
      pNamesL(42) = "IDMPFLD"
      pValuesD(42) = IDMPFLD
      pNamesL(43) = "IDMPPAR"
      pValuesL(43) = IDMPPAR
      pNamesL(44) = "ILOG"
      pValuesL(44) = ILOG
      pNamesL(45) = "LOUT_1"
      pValuesL(45) = LOUT(1)
      pNamesL(46) = "LOUT_2"
      pValuesL(46) = LOUT(2)
      pNamesL(47) = "LOUT_3"
      pValuesL(47) = LOUT(3)
      pNamesL(48) = "LOUT_4"
      pValuesL(48) = LOUT(4)
      pNamesL(49) = "LOUT_5"
      pValuesL(49) = LOUT(5)
      pNamesL(50) = "LOUT_6"
      pValuesL(50) = LOUT(6)
      pNamesL(51) = "LOUT_7"
      pValuesL(51) = LOUT(7)
      pNamesL(52) = "LOUT_8"
      pValuesL(52) = LOUT(8)
      pNamesL(53) = "LOUT_9"
      pValuesL(53) = LOUT(9)
      pNamesL(54) = "LOUT_10"
      pValuesL(54) = LOUT(10)
      pNamesL(55) = "LOUT_11"
      pValuesL(55) = LOUT(11)
      pNamesL(56) = "LOUT_12"
      pValuesL(56) = LOUT(12)
      pNamesL(57) = "LOUT_13"
      pValuesL(57) = LOUT(13)
      pNamesL(58) = "LOUT_14"
      pValuesL(58) = LOUT(14)
c
      do j = 1,2
         i = SDDS_DefineParameter_F(fileindex,pNamesS(j),"","","","",
     +        SDDS_STRING,pValuesS(j))
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
      end do
      do j = 1,49
         i = SDDS_DefineParameter1_F(fileindex,pNamesD(j),"","","",
     +        "",SDDS_DOUBLE,pValuesD(j))
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
      end do
      do j = 1,58
         i = SDDS_DefineParameter1_F(fileindex,pNamesL(j),"","","",
     +        "",SDDS_LONG,pValuesL(j))
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
      end do
      do j=1,NHMAX
         write(pname,'(I2)') 14+j
         pname = 'LOUT_' // pname
         i = SDDS_DefineParameter1_F(fileindex,pname,"","","","",
     +        SDDS_LONG,LOUT(14+j))
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
      enddo

      RETURN
      END
      
