      SUBROUTINE SCANINIT
c     ============================================================
c     Initialize beam parameter for scanning
c     ------------------------------------------------------------
c
      INCLUDE 'genesis.def'
      INCLUDE 'input.cmn'
      INCLUDE 'sim.cmn'
c
      IF (ISCAN.LE.0) RETURN
c
      NPART0=NPART
      IF (ISCAN.EQ.1 ) SVAL=GAMMA0      !save original value
      IF (ISCAN.EQ.2 ) SVAL=DELGAM
      IF (ISCAN.EQ.3 ) SVAL=CURPEAK
      IF (ISCAN.EQ.4 ) SVAL=XLAMDS        !save original value
      IF (ISCAN.EQ.5 ) SVAL=AW0
      IF (ISCAN.EQ.6 ) SVAL=DBLE(ISEED)
      IF (ISCAN.EQ.7 ) SVAL=PXBEAM
      IF (ISCAN.EQ.8 ) SVAL=PYBEAM
      IF (ISCAN.EQ.9 ) SVAL=XBEAM
      IF (ISCAN.EQ.10) SVAL=YBEAM
      IF (ISCAN.EQ.11) SVAL=RXBEAM
      IF (ISCAN.EQ.12) SVAL=RYBEAM     
      IF (ISCAN.EQ.13) SVAL=XLAMD
      IF (ISCAN.EQ.14) SVAL=DELAW
      IF (ISCAN.EQ.15) SVAL=ALPHAX      
      IF (ISCAN.EQ.16) SVAL=ALPHAY
      IF (ISCAN.EQ.17) SVAL=EMITX
      IF (ISCAN.EQ.18) SVAL=EMITY
      IF (ISCAN.EQ.19) SVAL=PRAD0
      IF (ISCAN.EQ.20) SVAL=ZRAYL
      IF (ISCAN.EQ.21) SVAL=ZWAIST
      IF (ISCAN.EQ.22) SVAL=AWD
c
      RETURN
      END
c
c
      SUBROUTINE DOSCAN(ISLICE)
c     =========================================================================
c     Modify parameter for scanning - several subroutines have to be rerun
c     -------------------------------------------------------------------------
c
      INCLUDE 'genesis.def'
      INCLUDE 'field.cmn'
      INCLUDE 'input.cmn'
      INCLUDE 'particle.cmn'
      INCLUDE 'sim.cmn'
      INCLUDE 'time.cmn'
c
      REAL*8 scale
      INTEGER islice
c
      if (ISCAN.LE.0) return
      NPART=NPART0 !compensate former particle losses
c
      scale=1.+svar*(2.*FLOAT(islice-1)/float(nslice-1)-1.)
      svalout=sval*scale   !save for output
      if (iscan.eq.6) svalout=sval+islice-1
c
c     beam parameters
c
      IF (ISCAN.EQ.1 ) GAMMA0=sval*scale
      IF (ISCAN.EQ.2 ) DELGAM=sval*scale
      IF (ISCAN.EQ.3 ) xcuren=sval*scale
      IF (ISCAN.EQ.7 ) PXBEAM=sval*scale
      IF (ISCAN.EQ.8 ) PYBEAM=sval*scale
      IF (ISCAN.EQ.9 ) XBEAM=sval*scale
      IF (ISCAN.EQ.10) YBEAM=sval*scale
      IF (ISCAN.EQ.11) RXBEAM=sval*scale
      IF (ISCAN.EQ.12) RYBEAM =sval*scale    
      IF (ISCAN.EQ.15) ALPHAX=sval*scale      
      IF (ISCAN.EQ.16) ALPHAY=sval*scale
      IF (ISCAN.EQ.17) EMITX=sval*scale
      IF (ISCAN.EQ.18) EMITY=sval*scale
      if (iscan.le.3) return
      if ((iscan.ge. 7).and.(iscan.le.12)) return
      if ((iscan.ge.15).and.(iscan.le.18)) return
c
c     radiation parameters
c
      IF (ISCAN.EQ.4 ) then
          XLAMDS=sval*scale       
          xks=twopi/xlamds
          call getdiag(delz*xlamd,dxy/xkper0,xks)
      endif    
      IF (ISCAN.EQ.19) PRAD0=sval*scale
      IF (ISCAN.EQ.20) ZRAYL=sval*scale
      IF (ISCAN.EQ.21) ZWAIST=sval*scale
      IF (ISCAN.EQ.22) AWD=sval*scale
      if ((iscan.eq.4).or.(iscan.ge.19)) return
c
c     magnets parameter
c
      IF (ISCAN.EQ.5 ) AW0=sval*scale
      IF (ISCAN.EQ.13) XLAMD=sval*scale
      IF (ISCAN.EQ.14) DELAW=sval*scale
      if (iscan.ne.6)  scale=RAN1(-NINT(sval)) !reinit ran1 function
      call magfield(xkw0)                      !recalculate magnetic field
      if (iscan.eq.13) call getdiag(DELZ*XLAMD,DXY/XKPER0,XKS)
      RETURN
      END
c
