      Subroutine SOURCE(ISTEPZ)
c     ==================================================================
c     Construct the source for the wave equation
c     = radiation of the electron beam
c     ------------------------------------------------------------------
c
      INCLUDE 'genesis.def'
      INCLUDE 'field.cmn'
      INCLUDE 'input.cmn'
      INCLUDE 'magnet.cmn'
      INCLUDE 'particle.cmn'
      INCLUDE 'work.cmn'
c
      INTEGER ip,j,idx,istepz
      COMPLEX*16 CTEMP
      REAL*8 stemp,wei
c
c
      Do J=1,NCAR*NCAR
	CRSOURCE(J)= (0.d0,0.d0)     !Clear 2D array
      End Do     ! J
c
      IF (AWZ(ISTEPZ).LT.TINY) RETURN        !drift !!!
c
      STEMP=0.5D0*VACIMP/EEV*FBESS*XCUREN/FLOAT(NPART)*XLAMD/XLAMDS
      STEMP=STEMP*DELZ*twopi/DXY/DXY/2.d0  !constant factor 2 because source term is used twice
c
      CALL RPOS(istepz,XPART,YPART)      !get particle position on grid
c
      Do IP=1,NPART                  !get undulator field at particle position
       P1(IP)=DSQRT(FAW2(ISTEPZ,XPORB(IP),YPORB(IP)))
     c         *STEMP/GAMMA(IP)/BTPAR(IP)
      End Do       ! IP
c
c     Load source term with current density
c
      DO IP=1,NPART
        CTEMP=DCMPLX(0.d0,P1(IP))
     +       *DCMPLX(DCOS(THETA(IP)),-DSIN(THETA(IP)))
        wei=wx(ip)*wy(iP)
        idx=ipos(1,ip)
        CRSOURCE(idx)=CRSOURCE(idx)+wei*CTEMP
        wei=wx(ip)*(1.d0-wy(ip))
        idx=ipos(2,ip)
        CRSOURCE(idx)=CRSOURCE(idx)+wei*CTEMP
        wei=(1.d0-wx(ip))*wy(iP)
        idx=ipos(3,ip)
        CRSOURCE(idx)=CRSOURCE(Idx)+wei*CTEMP
        wei=(1.d0-wx(ip))*(1.d0-wy(ip))
        idx=ipos(4,ip)
        CRSOURCE(idx)=CRSOURCE(IDX)+wei*CTEMP
      END DO
c
      Return
      End     !SOURCE
c
