      Subroutine DOTIME(ISLICE)
c     ===================================================================
c     Set the beam parameter for the case of time-dependence
c     -------------------------------------------------------------------
c   
      INCLUDE 'genesis.def'
      INCLUDE 'input.cmn'
      include 'particle.cmn'
      INCLUDE 'time.cmn'
      include 'sim.cmn'
c
      INTEGER i,idx,islice
      REAL*8 invcur,zpos,w1,w2
      character*30 cdiff

      IF (ITDP.EQ.0) return
c
      IF (ISLICE.EQ.1) then
           NPART0=NPART    !save #particles
           w1=RAN1(IPSEED) !init ran1
      ENDIF     
c
      NPART=NPART0   !compensate former particle losses
c
      IF (NDATA.LE.1) THEN  !internal generation of time-dependence
         if (curlen.le.0.0) then
            invcur=0.
         else
            invcur=1./curlen
         endif
         ZPOS=dble(NTAIL+ISLICE-1)*ZSEP*XLAMDS*invcur  !normalized t-position
         XCUREN= CURPEAK*DEXP(-0.5d0*ZPOS*ZPOS)          !Beam current
         RETURN
      endif
c
      ZPOS=dble((NTAIL+ISLICE-1)*ZSEP)*XLAMDS  !position in m
      IDX=LUF(ZPOS,TPOS,NDATA)-1           !find position in array
      IF (IDX.LE.0) THEN
        write(cdiff,*) (zpos-tpos(1)) 
        I=PRINTERR(ERREXTRA,cdiff)            
        IDX=1
      ENDIF
      IF (IDX.GE.NDATA) THEN
        write(cdiff,*) (zpos-tpos(NDATA)) 
        I=PRINTERR(ERREXTRA,cdiff)            
        IDX=NDATA-1
      ENDIF
      W2=(ZPOS-TPOS(IDX))/(TPOS(IDX+1)-TPOS(IDX)) !weight of higher index
      W1=1.d0-W2                                  !weight of lower index       
      GAMMA0=W1*TGAM0(IDX)+W2*TGAM0(IDX+1)  !interpolation
      DELGAM=W1*TDGAM(IDX)+W2*TDGAM(IDX+1)  !temporary stored
      RXBEAM=W1*TXRMS(IDX)+W2*TXRMS(IDX+1)  !into working arays
      RYBEAM=W1*TYRMS(IDX)+W2*TYRMS(IDX+1)
      XBEAM=W1*TXPOS(IDX)+W2*TXPOS(IDX+1)
      YBEAM=W1*TYPOS(IDX)+W2*TYPOS(IDX+1)
      EMITX=W1*TEMITX(IDX)+W2*TEMITX(IDX+1)
      EMITY=W1*TEMITY(IDX)+W2*TEMITY(IDX+1)
      PXBEAM=W1*TPXPOS(IDX)+W2*TPXPOS(IDX+1)
      PYBEAM=W1*TPYPOS(IDX)+W2*TPYPOS(IDX+1)
      ALPHAX=W1*TALPHX(IDX)+W2*TALPHX(IDX+1)
      ALPHAY=W1*TALPHY(IDX)+W2*TALPHY(IDX+1)
      XCUREN=W1*TCURRENT(IDX)+W2*TCURRENT(IDX+1)  
      DEDZ=(W1*TLOSS(IDX)+W2*TLOSS(IDX+1))*delz*XLAMD/eev 

      RETURN
            
      end  ! of DOTIME

