      SUBROUTINE OPENTIMEREC(n)
c     ==================================================================
c     Opens a scratch-file for the time record if necessary
c     ------------------------------------------------------------------
c  
      include 'genesis.def'
      include 'timerec.cmn'
c      
      integer n
c
      if (NOFILE.NE.0) THEN     !write CRTIME to disk?
        NTMP=13
        OPEN(NTMP,status='scratch',ACCESS='DIRECT',RECL=N*N*16,ERR=100)
      ENDIF
      RETURN
c
 100  NTMP=PRINTERR(ERROPEN,'CRTIME-scratch')
      CALL LAST
      RETURN
      END


      SUBROUTINE PUSHTIMEREC(CPUSH,n,irec)
c     ==================================================================
c     Copies CPUSH into CRTIME Array/file
c     ------------------------------------------------------------------

      include 'genesis.def'
      include 'timerec.cmn'

      integer n,it,irec
      COMPLEX*16 CPUSH(n*n)

      if (NOFILE.EQ.0) THEN
         DO it=1,n*n
            crtime(irec*n*n+it)=cpush(it)
         enddo
      ELSE 
         write(ntmp,rec=irec+1,ERR=10) (cpush(it),it=1,n*n)
      ENDIF
      RETURN
 10   it=PRINTERR(ERRREAD,'CRTIME-scratch')
      CALL LAST
      RETURN
      END  !of PUSHTIMEREC
c
c
      SUBROUTINE PULLTIMEREC(CPUll,n,irec)
c     ==================================================================
c     Copies CRTIME Array/file into CPUSH
c     ------------------------------------------------------------------

      include 'genesis.def'
      include 'timerec.cmn'

      integer n,it,irec
      COMPLEX*16 CPUll(n*n)

      if (NOFILE.EQ.0) THEN
         DO it=1,n*n
            cpull(it)=DCMPLX(crtime(irec*n*n+it))
         enddo
      ELSE 
         read(ntmp,rec=irec+1,ERR=10) (cpull(it),it=1,n*n)
      ENDIF
      RETURN
 10   it=PRINTERR(ERRREAD,'CRTIME-scratch')
      CALL LAST
      RETURN

      END  !of PULLTIMEREC


      SUBROUTINE CLOSETIMEREC
c     ====================================================================
c     close the scratch file if necessary
c     --------------------------------------------------------------------
c
      include 'genesis.def'
      include 'timerec.cmn'
c
      if (NOFILE.NE.0) CLOSE(NTMP)
      RETURN
      END
