      Subroutine TRACK(ISTEPZ,xkper0)
c     ==================================================================
c     Calculates exact soultion for transverse motion
c     This subroutine is call before and after Runge-Kutta integration
c     of Phase and Energy
c     ------------------------------------------------------------------
c
      INCLUDE 'genesis.def'
      INCLUDE 'input.cmn'
      INCLUDE 'magnet.cmn'
      INCLUDE 'particle.cmn'
c
      REAL*8 A1,A2,A3,XTMP,FOC,OMG,qx,qy,betpar0,xkper0
      INTEGER IP,istepz
c
      DELZ=DELZ*0.5
c
      BETPAR0=1.+AWZ(Istepz)**2                ! add weak focusing
      BETPAR0=DSQRT(1.d0-BETPAR0/GAMMA0/GAMMA0)
      QX= qfld(istepz)+XKX*xkper0**2*AWZ(Istepz)**2/GAMMA0/BETPAR0
      QY=-qfld(istepz)+XKY*xkper0**2*AWZ(Istepz)**2/GAMMA0/BETPAR0
c
      IF (QX.EQ.0.) THEN
         DO IP=1,NPART
            XPART(IP)=XPART(IP)+PX(IP)*twopi*DELZ/GAMMA(IP)/BTPAR(IP)
         ENDDO
      ELSE 
         IF (QX.GT.0.) THEN
            DO IP=1,NPART
               FOC=DSQRT(DABS(QX)/GAMMA(IP)/BTPAR(IP))
               OMG=FOC*DELZ*XLAMD
               A1=DCOS(OMG)
               A2=DSIN(OMG)/FOC
               A3=-A2*FOC*FOC
               XTMP=A1*XPART(IP)+A2*PX(IP)/GAMMA(IP)/BTPAR(IP)*xkper0
               PX(IP)=A3*XPART(IP)*GAMMA(IP)*BTPAR(IP)/xkper0+A1*PX(IP)
               XPART(IP)=XTMP
            ENDDO
         ELSE
            DO IP=1,NPART
               FOC=DSQRT(DABS(QX)/GAMMA(IP)/BTPAR(IP))
               OMG=FOC*DELZ*XLAMD
               A1=DCOSH(OMG)
               A2=DSINH(OMG)/FOC
               A3=A2*FOC*FOC
               XTMP=A1*XPART(IP)+A2*PX(IP)/GAMMA(IP)/BTPAR(IP)*xkper0
               PX(IP)=A3*XPART(IP)*GAMMA(IP)*BTPAR(IP)/xkper0+A1*PX(IP)
               XPART(IP)=XTMP
            ENDDO
         ENDIF
      ENDIF
c
c     field error
c
      IF (DABS(AWERX(ISTEPZ)).GT.TINY) THEN
         DO IP=1,NPART
            PX(IP)=PX(IP)+AWERX(ISTEPZ)*DELZ*twopi
            XPART(IP)=XPART(IP)+                         !kick at 0.5*DELZ
     +                AWERX(ISTEPZ)*0.5*DELZ*twopi/GAMMA(IP)/BTPAR(IP) 
         ENDDO
      ENDIF
c
c     solenoid field
c
      IF (DABS(SOLZ(ISTEPZ)).GT.TINY) THEN
         DO IP=1,NPART
            A1=SOLZ(ISTEPZ)*DELZ*XLAMD/GAMMA(IP) 
            PX(IP)=PX(IP)+A1*PY(IP)
            XPART(IP)=XPART(IP)+0.5*A1/GAMMA(IP)/BTPAR(IP) !kick at 0.5*DELZ
         ENDDO
      ENDIF
c      
c     and now for the y-plane
c
      IF (QY.EQ.0.) THEN
         DO IP=1,NPART
            YPART(IP)=YPART(IP)+PY(IP)*DELZ*twopi/GAMMA(IP)/BTPAR(IP)
         ENDDO
      ELSE 
         IF (QY.GT.0.) THEN
            DO IP=1,NPART
               FOC=DSQRT(DABS(QY)/GAMMA(IP)/BTPAR(IP))
               OMG=FOC*DELZ*xlamd
               A1=DCOS(OMG)
               A2=DSIN(OMG)/FOC
               A3=-A2*FOC*FOC
               XTMP=A1*YPART(IP)+A2*PY(IP)/GAMMA(IP)/BTPAR(IP)*xkper0
               PY(IP)=A3*YPART(IP)*GAMMA(IP)*BTPAR(IP)/xkper0+A1*PY(IP)
               YPART(IP)=XTMP
            ENDDO
         ELSE
            DO IP=1,NPART
               FOC=DSQRT(DABS(QY)/GAMMA(IP)/BTPAR(IP))
               OMG=FOC*DELZ*xlamd
               A1=DCOSH(OMG)
               A2=DSINH(OMG)/FOC
               A3=A2*FOC*FOC
               XTMP=A1*YPART(IP)+A2*PY(IP)/GAMMA(IP)/BTPAR(IP)*xkper0
               PY(IP)=A3*YPART(IP)*GAMMA(IP)*BTPAR(IP)/xkper0+A1*PY(IP)
               YPART(IP)=XTMP
            ENDDO
         ENDIF
      ENDIF
c
      IF (DABS(AWERY(ISTEPZ)).GT.TINY) THEN
         DO IP=1,NPART
            PY(IP)=PY(IP)+AWERY(ISTEPZ)*DELZ*twopi
            YPART(IP)=YPART(IP)
     +               +AWERY(ISTEPZ)*0.5*DELZ*twopi/GAMMA(IP)/BTPAR(IP) 
         ENDDO
      ENDIF
c
c
c     solenoid field
c
      IF (DABS(SOLZ(ISTEPZ)).GT.TINY) THEN
         DO IP=1,NPART
            A1=SOLZ(ISTEPZ)*DELZ*XLAMD/GAMMA(IP) 
            PY(IP)=PY(IP)-A1*PX(IP)
            YPART(IP)=YPART(IP)-0.5*A1/GAMMA(IP)/BTPAR(IP) !kick at 0.5*DELZ
         ENDDO
      ENDIF
c      
      DELZ=DELZ*2.
c      
      RETURN
      END 
